diff -Nacr cvs/subr.el new/subr.el
*** cvs/subr.el	2005-07-14 13:25:56.000000000 -0600
--- new/subr.el	2005-07-14 13:28:41.000000000 -0600
***************
*** 2390,2395 ****
--- 2390,2399 ----
        (subrp object) (byte-code-function-p object)
        (eq (car-safe object) 'lambda)))
  
+ (defun special-form-p (object)
+   "Return t if OBJECT is a special form."
+   (and (subrp object) (eq (cdr (subr-arity object)) 'unevalled)))
+ 
  (defun assq-delete-all (key alist)
    "Delete from ALIST all elements whose car is `eq' to KEY.
  Return the modified alist.
diff -Nacr cvs/advice.el new/advice.el
*** cvs/advice.el	2005-07-14 13:21:29.000000000 -0600
--- new/advice.el	2005-07-14 13:28:51.000000000 -0600
***************
*** 2464,2487 ****
    "Take a macro function DEFINITION and make a lambda out of it."
    `(cdr ,definition))
  
- ;; There is no way to determine whether some subr is a special form or not,
- ;; hence we need this list (which is probably out of date):
- (defvar ad-special-forms
-   (let ((tem '(and catch cond condition-case defconst defmacro
- 		   defun defvar function if interactive let let*
- 		   or prog1 prog2 progn quote save-current-buffer
- 		   save-excursion save-restriction save-window-excursion
- 		   setq setq-default unwind-protect while
- 		   with-output-to-temp-buffer)))
-     ;; track-mouse could be void in some configurations.
-     (if (fboundp 'track-mouse)
- 	(push 'track-mouse tem))
-     (mapcar 'symbol-function tem)))
- 
- (defmacro ad-special-form-p (definition)
-   ;;"non-nil if DEFINITION is a special form."
-   (list 'memq definition 'ad-special-forms))
- 
  (defmacro ad-interactive-p (definition)
    ;;"non-nil if DEFINITION can be called interactively."
    (list 'commandp definition))
--- 2464,2469 ----
***************
*** 2644,2650 ****
    (if (ad-macro-p definition)
        'macro
      (if (ad-subr-p definition)
! 	(if (ad-special-form-p definition)
  	    'special-form
  	  'subr)
        (if (or (ad-lambda-p definition)
--- 2626,2632 ----
    (if (ad-macro-p definition)
        'macro
      (if (ad-subr-p definition)
! 	(if (special-form-p definition)
  	    'special-form
  	  'subr)
        (if (or (ad-lambda-p definition)
***************
*** 3062,3068 ****
  	     (origname (ad-get-advice-info-field function 'origname))
  	     (orig-interactive-p (ad-interactive-p origdef))
  	     (orig-subr-p (ad-subr-p origdef))
! 	     (orig-special-form-p (ad-special-form-p origdef))
  	     (orig-macro-p (ad-macro-p origdef))
  	     ;; Construct the individual pieces that we need for assembly:
  	     (orig-arglist (ad-arglist origdef function))
--- 3044,3050 ----
  	     (origname (ad-get-advice-info-field function 'origname))
  	     (orig-interactive-p (ad-interactive-p origdef))
  	     (orig-subr-p (ad-subr-p origdef))
! 	     (orig-special-form-p (special-form-p origdef))
  	     (orig-macro-p (ad-macro-p origdef))
  	     ;; Construct the individual pieces that we need for assembly:
  	     (orig-arglist (ad-arglist origdef function))
